          section   TEXT

          xdef      _fi2_hget
          xref      __usefi2
          xref      __freefi2

* Prototype: int fi2_hget(int param_code, short * record_number, \
*                         char * record_param);

_fi2_hget MOVEM.L   D3/A2/A4,-(SP)                Save the context.
          MOVE.L    #'HGET',D2                    Extension to be used.
          JSR       __usefi2                      Use it.
          BNE.S     FI2HGET1                      If error, return now.
          LEA       16(SP),A2                     Pointer on first parameter.
          MOVE.L    (A2)+,D1                      Get "param_code" value.
          MOVEA.L   (A2)+,A0                      Pointer on "record_number".
          MOVE.W    (A0),D2                       Get "record_number" value.
          JSR       (A4)                          Call the extension.
          BNE.S     FI2HGET2                      If error, return now.
          TST.L     D1                            Was D1 = 0 ?
          BNE.S     FI2HGET3                      If no, jump over...
          MOVE.W    D3,(A0)                       Store record_number value.
          BRA.S     FI2HGET2                      And return.
FI2HGET3  MOVE.W    (A1)+,D1                      Number of characters.
          MOVEA.L   (A2),A0                       Pointer on "record_param" str.
          BRA.S     FI2HGET4                      Start to copy the string.
FI2HGET5  MOVE.B    (A1)+,(A0)+                   Copy a character.
FI2HGET4  DBRA      D1,FI2HGET5                   Repeat for the whole string.
          CLR.B     (A0)                          Put the ending 0.
FI2HGET2  JSR       __freefi2                     Free the extension thing.
FI2HGET1  MOVEM.L   (SP)+,D3/A2/A4                Restore the context.
          RTS                                     Return to calling function.

          end
