          section   TEXT

          xdef      _fi2_make
          xref      __usefi2
          xref      __freefi2
          xref      __getext

* Prototype: int fi2_make(char * ext, char * data_id, FI2ACTION_t * bloc);

_fi2_make MOVEM.L   D3/A2/A4,-(SP)                Save the context.
          MOVE.L    #'MAKE',D2                    Extension to be used.
          JSR       __usefi2                      Use it.
          BNE.S     FI2MAKE1                      If error, return now.
          MOVEA.L   20(SP),A1                     Address of "data_id" string.
          JSR       __getext                      Get the data_id.
          BNE.S     FI2MAKE2                      If error, return now.
          MOVE.L    D1,D3                         Save the data_id.
          MOVEA.L   16(SP),A1                     Address of "ext" string.
          JSR       __getext                      Get the "ext" name.
          BNE.S     FI2MAKE2                      If error, return now.
          MOVEA.L   24(SP),A0                     Pointer on "bloc" structure.
          MOVEQ     #0,D2                         Pointers are absolute.
          JSR       (A4)                          Call the extension.
          BNE.S     FI2MAKE2                      If error, return now.
          MOVE.L    A1,24(A0)                     Store the new bloc address.
FI2MAKE2  JSR       __freefi2                     Free the extension thing.
FI2MAKE1  MOVEM.L   (SP)+,D3/A2/A4                Restore the context.
          RTS                                     Return to calling function.

          end
