          section   TEXT

          xdef      _fi2_scan
          xref      __usefi2
          xref      __freefi2
          xref      __getext

* Prototype: int fi2_scan(char * ext, short * actions, \
*                         char * next, int flag, void ** array);

_fi2_scan MOVEM.L   D3/A2/A4,-(SP)                Save the context.
          MOVE.L    #'SCAN',D2                    Extension to be used.
          JSR       __usefi2                      Use it.
          BNE.S     FI2SCAN1                      If error, return now.
          LEA       16(SP),A2                     Pointer on first parameter.
          MOVEA.L   (A2),A1                       Address of ext name (C str).
          JSR       __getext                      Put the ext into D1.L.
          BNE.S     FI2SCAN2                      If error, return now.
          MOVE.L    12(A2),D2                     Get the flag value.
          JSR       (A4)                          Call the extension.
          BNE.S     FI2SCAN2                      If error, return now.
          MOVEA.L   4(A2),A0                      Address of "actions" variable.
          MOVE.W    D2,(A0)                       Store the number of actions.
          TST.L     12(A2)                        Was the flag set ?
          BEQ.S     FI2SCAN5                      If not, jump over...
          MOVEA.L   16(A2),A0                     Address of "array" variable.
          MOVE.L    A1,(A0)                       Store address of the array.
FI2SCAN5  MOVEA.L   8(A2),A0                      Address of "next" string.
          MOVEQ     #3,D2                         Four chars max for next ext.
FI2SCAN7  ROL.L     #8,D1                         Put next ext char into LSB.
          TST.B     D1                            Is there a char ?
          BEQ.S     FI2SCAN6                      If no, jump over...
          MOVE.B    D1,(A0)+                      Store char into "next" str.
FI2SCAN6  DBRA      D2,FI2SCAN7                   Repeat with next char.
          CLR.B     (A0)                          End of "next" string.
FI2SCAN2  JSR       __freefi2                     Free the extension thing.
FI2SCAN1  MOVEM.L   (SP)+,D3/A2/A4                Restore the context.
          RTS                                     Return to calling function.

          end
